library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_arith.all;
use IEEE.std_logic_unsigned.all;

--------------------------------------------------------------
-- p=2**192 - 2**64 - 1
--------------------------------------------------------------
package my_package is
constant k: integer := 192; 
constant logk: integer := 8;
constant exp_k: std_logic_vector(k-1 downto 0) := 
x"000000000000000000000000000000010000000000000001"; 
constant exp_2k: std_logic_vector(k-1 downto 0) := 
x"000000000000000100000000000000020000000000000001";
constant p: std_logic_vector(k-1 downto 0) := 
x"FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFFFFFFFFFFFF";
constant p_minus2: std_logic_vector(k-1 downto 0) := x"FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFFFFFFFFFFFD";
end my_package;

------------------------------------------------------------
-- p = 2**32 - 387
--------------------------------------------------------------
--package my_package is
--constant k: integer := 32; 
--constant logk: integer := 5;
--constant exp_k: std_logic_vector(k-1 downto 0) := 
--x"00000183"; 
--constant exp_2k: std_logic_vector(k-1 downto 0) := 
--x"00024909";
--constant p: std_logic_vector(k-1 downto 0) := 
--x"FFFFFE7D";
--constant p_minus2: std_logic_vector(k-1 downto 0) := 
--x"FFFFFE7B";
--end my_package;

--------------------------------------------------------------
-- p = 239
--------------------------------------------------------------
--package my_package is
--constant k: integer := 8;
--constant logk: integer := 3;
--constant exp_k: std_logic_vector(k-1 downto 0) := x"11";
--constant exp_2k: std_logic_vector(k-1 downto 0) := x"32";
--constant p: std_logic_vector(k-1 downto 0) := x"EF";
--constant p_minus2: std_logic_vector(k-1 downto 0) := x"ED";
--end my_package;
--